var reverseMouseDown = false;
var reverseMouseOver = false;
var randomMouseDown = 0;
var randomMouseOver = 0;
var playMouseDown = false;
var playMouseOver = false;
var forwardMouseDown = false;
var forwardMouseOver = false;
var randomState;

var spacerTick = 0;
var timeDisplayType = preferences.timeDisplayPref.value;

var currentPlayMode = "stopped";
var totalTime = 0;

if (iTunes.running) {
	playState();
	updateMutant();
	doRandomState();
} else {
	if (system.platform == "macintosh") {
		appleScript('tell app "iTunes" to launch');
		appleScript('tell application "System Events" to tell process "iTunes" to set visible to false');
	}
}
changePref();

function changePref() {
	suppressUpdates();
	
	var mutantType = preferences.mutantTypePref.value;
	if (mutantType == "none") {
		track.opacity = 0;
		artist.opacity = 0;
		mutant.opacity = 0;
		timeSlider.opacity = 0;
		timeTab.opacity = 0;
		volSlider.opacity = 0;
		volTab.opacity = 0;
	} else {
		track.scrolling = (preferences.scrollTitlePref.value == true) ? "autoLeft" : "off";
		track.opacity = 255;
		artist.opacity = 255;
		mutant.opacity = 255;
		volSlider.opacity = 255;
		volTab.opacity = 255;
		mutant.src = "Images/"+mutantType+"/mutant.png";
		volSlider.src = "Images/wolverine/volSlider.png";
		timeSlider.src = "Images/wolverine/timeSlider.png";
		timeTab.src = "Images/wolverine/timeTab.png";
		updateMutant();
	}
	resumeUpdates();
}

//--
function playButtonPush() {
	if (currentPlayMode == "playing") {
		playButton.src = "Images/btn/pause_over.png";
	} else {
		playButton.src = "Images/btn/play_over.png";
	}
}

function playState() {
	switch (iTunes.playerStatus) {
		case "stopped":
			playButton.src = "Images/btn/play.png";
			currentPlayMode = "stopped";
			break;
		case "paused":
			playButton.src = "Images/btn/play.png";
			currentPlayMode = "paused";
			break;
		default:
			playButton.src = "Images/btn/pause.png";
			currentPlayMode = "playing";
	}
}

function doRandomState(action)
{
	if ( action == "switch" )
	{
		randomState = iTunes.shuffle;
		if ( randomState )
			randomState = iTunes.shuffle = false;
		else
			randomState = iTunes.shuffle = true;
		if ( randomState )
		{
			if (iTunes.trackType == "audio stream")
				randomButton.src = "Images/btn/shuffle_off.png";
			else
				randomButton.src = "Images/btn/shuffle_on.png";
		}
		else
		{
			randomButton.src = "Images/btn/shuffle_off.png";
		}
		
	}
	else
	{
		if ( !randomMouseDown )
		{
			randomState = iTunes.shuffle;
			if ( randomState )
				randomButton.src = "Images/btn/shuffle_on.png";
			else
				randomButton.src = "Images/btn/shuffle_off.png";
		}
	}
}

function updateMutant() {
	suppressUpdates();
//	updateTitleFld();
//	updateArtistFld();
	updateArtistTitleFld();
	if (preferences.mutantTypePref.value != "none"){
		updateTimeFld();
		updateVolumeFld();
	}
	resumeUpdates();
}

function updateArtistTitleFld(){
	var theTitle = iTunes.trackTitle;
	if (theTitle == "missing value") {
		theTitle = iTunes.trackAlbum;
	}
	var theArtist = iTunes.trackArtist;
	if (theArtist == "missing value") {
		theArtist = iTunes.trackAlbum;
	}
	
	var trackStr = theArtist + " - " + theTitle;
	if (track.data != trackStr) {
		track.data = trackStr;
		base.tooltip = trackStr;
		totalTime = iTunes.trackLength;
		if (preferences.mutantTypePref.value != "none"){
			if (totalTime == 0) {
				timeTab.opacity = 0;
				timeSlider.opacity = 0;
			} else {
				timeTab.opacity = 255;
				timeSlider.opacity = 255;
			}
		}
		updateTypeFld();
	}
}

function updateTitleFld(){
	var theTitle = iTunes.trackTitle;
	if (theTitle == "missing value") {
		theTitle = iTunes.trackAlbum;
	}
	if (track.data != theTitle) {
		track.data = theTitle;
		base.tooltip = theTitle;
		totalTime = iTunes.trackLength;
		if (preferences.mutantTypePref.value != "none"){
			if (totalTime == 0) {
				timeTab.opacity = 0;
				timeSlider.opacity = 0;
			} else {
				timeTab.opacity = 255;
				timeSlider.opacity = 255;
			}
		}
		updateTypeFld();
	}
}

function updateArtistFld(){
	var theArtist = iTunes.trackArtist;
	if (theArtist == "missing value") {
		theArtist = iTunes.trackAlbum;
	}
	if (artist.data != theArtist) {
		artist.data = theArtist;
		base.tooltip = theArtist;
		totalTime = iTunes.trackLength;
		if (preferences.mutantTypePref.value != "none"){
			if (totalTime == 0) {
				timeTab.opacity = 0;
				timeSlider.opacity = 0;
			} else {
				timeTab.opacity = 255;
				timeSlider.opacity = 255;
			}
		}
		updateTypeFld();
	}
}

function updateTypeFld(){
	switch (iTunes.trackType) {
		case "audio cd track":
			playType = "CD";
			break;
		case "audio stream":
		case "missing value":
			playType = "stream";
			break;
		default:
			playType = "file";
	}	
	playMode.src = "Images/mode/"+playType+".png";
}

function updateTimeFld() {
	if (timeTab.opacity) timeTab.hOffset = 133 + 128 * (iTunes.playerPosition / totalTime);
}

function updateTrackTime() {
	var x = system.event.x;
	if (x < 5) {
		x = 0;
		timeTab.hOffset = 133;
	} else if (x > 130) {
		x = 128;
		timeTab.hOffset = 133+128;
	} else {
		x -= 3;
		timeTab.hOffset = 133 + x;
	}
	iTunes.playerPosition = (x/128) * totalTime;
}

function updateVolumeFld() {
	volTab.hOffset = 207 + iTunes.volume/2;
}

function updateVolume() {
	var x = system.event.x;
	if (x < 5) {
		x = 0;
		volTab.hOffset = 207;
	} else if (x > 52) {
		x = 50;
		volTab.hOffset = 207 + 50;
	} else {
		x -= 5;
		volTab.hOffset = 207 + x;
	}
	iTunes.volume = x * 2;
}

function getRepeatState()
{
	if (iTunes.repeatMode)
	{
		switch (iTunes.repeatMode)
		{
			case "all":
				return "one";
				break
			case "off":
				return "all";
				break
			case "one":
				return "off";
				break
		}
	}
	else return false;
}

function switchRpt()
{
	switch (iTunes.repeatMode)
	{
		case "all":
			iTunes.repeatMode = "one";
			break
		case "off":
			iTunes.repeatMode = "all";
			break
		case "one":
			iTunes.repeatMode = "off";
			break
	}
	
	UpDate();
}